﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Core;
using HeuristicLab.Optimization;
using HeuristicLab.Common;
using System.Drawing;

namespace HeuristicLab.Clients.OKB {
  [Creatable("OKB")]
  [Item("OKB Experiment", "...")]
  public sealed class OKBExperiment : NamedItem, IOptimizer, IStorableContent {
    public string Filename { get; set; }

    public override Image ItemImage {
      get {
        if (ExecutionState == ExecutionState.Prepared) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutablePrepared;
        else if (ExecutionState == ExecutionState.Started) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutableStarted;
        else if (ExecutionState == ExecutionState.Paused) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutablePaused;
        else if (ExecutionState == ExecutionState.Stopped) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutableStopped;
        else return HeuristicLab.Common.Resources.VS2008ImageLibrary.Event;
      }
    }

    public override bool CanChangeName {
      get { return false; }
    }
    public override bool CanChangeDescription {
      get { return false; }
    }

    private IAlgorithm algorithm;
    private IAlgorithm Algorithm {
      get { return algorithm; }
      set { algorithm = value; }
    }
    private IProblem problem;
    private IProblem Problem {
      get { return problem; }
      set { problem = value; }
    }

    public void LoadAlgorithm(long algorithmId) {

    }
    public void LoadProblem(long problemId) {

    }



    #region IOptimizer Members

    public void Prepare(bool clearRuns) {
      throw new System.NotImplementedException();
    }

    public RunCollection Runs {
      get { throw new System.NotImplementedException(); }
    }

    #endregion

    #region IExecutable Members

    public event System.EventHandler<EventArgs<System.Exception>> ExceptionOccurred;

    public ExecutionState ExecutionState {
      get { throw new System.NotImplementedException(); }
    }

    public event System.EventHandler ExecutionStateChanged;

    public System.TimeSpan ExecutionTime {
      get { throw new System.NotImplementedException(); }
    }

    public event System.EventHandler ExecutionTimeChanged;

    public void Pause() {
      throw new System.NotImplementedException();
    }

    public event System.EventHandler Paused;

    public void Prepare() {
      throw new System.NotImplementedException();
    }

    public event System.EventHandler Prepared;

    public void Start() {
      throw new System.NotImplementedException();
    }

    public event System.EventHandler Started;

    public void Stop() {
      throw new System.NotImplementedException();
    }

    public event System.EventHandler Stopped;

    #endregion
  }
}
